<template>
  <b-container class="mt-5" style="max-width: 400px;">
    <b-row>
      <b-col cols="12" style="width: 30px;">
        <p class="head-text mt-3">ID</p>
        <b-col class="mt-4">
          <b class="text-blue"> {{ drone.id }} </b>
        </b-col>
        <hr class="tr-row" />
      </b-col>
    </b-row>
    <b-row>
      <b-col cols="12">
        <p class="head-text">CUSTOMER</p>
        <div class="centered">
          <b-media style="margin-left: 25%">
            <template #aside>
              <b-img
                :src="drone.image"
                width="50"
                alt="placeholder"
                rounded="circle"
              ></b-img>
            </template>

            <h5 class="mt-2 mb-0 text-left">{{ drone.name }}</h5>
            <p class="mb-0 text-left address-subtitle">
              {{ drone.address }}
            </p>
          </b-media>
        </div>
        <hr class="tr-row" />
      </b-col>
    </b-row>
    <b-row>
      <b-col cols="12" style="width: 30px;">
        <p class="head-text">BATTERY</p>
        <div class="centered battery-div">
          <ProgressPercent :value="drone.battery"></ProgressPercent>
        </div>
        <hr class="tr-row" />
      </b-col>
    </b-row>
    <b-row>
      <b-col cols="12" style="width: 30px;">
        <p class="head-text">MAX SPEED</p>
        <b class="text-blue">
          {{ drone.max_speed }}<span class="miles">m/h</span>
        </b>
        <hr class="tr-row" />
      </b-col>
    </b-row>
    <b-row>
      <b-col cols="12">
        <p class="head-text">AVERAGE SPEED</p>
        <b class="text-blue">
          {{ drone.average_speed }}<span class="miles">m/h</span>
        </b>
        <hr class="tr-row" />
      </b-col>
    </b-row>
    <b-row>
      <b-col cols="12">
        <p class="head-text">CURENT FLY</p>
        <div class="centered battery-div mr-4">
          <LineFly :value="drone.fly" :status="drone.status"></LineFly>
        </div>
        <!-- <hr class="tr-row" /> -->
      </b-col>
    </b-row>
    <b-row>
      <b-col cols="12">
        <hr class="tr-row" />
        <p class="head-text">STATUS</p>
        <b-button
          size="sm"
          :disabled="['success', 'offline'].includes(drone.status)"
          :variant="getColor(drone.status)"
          >{{ drone.status.toUpperCase() }}</b-button
        >
      </b-col>
    </b-row>
  </b-container>
</template>

<script lang="ts">
import Vue from "vue";

import { SET_DRONE } from '@/store/drone'

import ProgressPercent from "@/components/ProgresPercent.vue";
import LineFly from "@/components/LineFly.vue";

import DroneService from "@/services/drone"

export default Vue.extend({
  name: "About",
  components: {
    ProgressPercent,
    LineFly,
  },
  data() {
    return {
      selectFly: null,
      status: null,
    };
  },
  async created() {
    if (!this.drone) {
      await this.getDrone()
    }
  },
  computed: {
    drone() {
      return this.$store.state.drone.drone;
    }
  },
  methods: {
    getColor(status: string) {
      switch (status) {
        case "failed":
          return "danger";
        case "delayed":
          return "warning";
        default:
          return "primary";
      }
    },
    async getDrone() {
      try {
        const id = parseInt(this.$route.params.id)
        const { data } = await DroneService.getById(id)
        this.$store.dispatch(SET_DRONE, data[0])
      } catch (error) {
        alert(error.message)
      }
    },
  }
});
</script>

<style>
.centered {
  text-align: center;
  margin: auto;
}
.battery-div {
  max-width: 250px;
}
</style>
